%eden

/* nextastep is an agent that responds to a click in the arrwin window
	it sets a trigger nexta to 1 to alert the bubbblesort agents */

proc nextastep: arrwin_mouse
{
        if (arrwin_mouse[2]==4 && nexta==0) nexta++;
}

/* in bubblesort, the state includes reference to the current pass number,
	and to the position i at which the exchange of i-th and (i+1)-st
	element is being contemplated. These are represented by the variables
	bs_pass and bs_pos respectively */

/* these definitions establish the initial conditions for bubblesort */

nexta = 0;
bs_pass=1;
bs_pos =1;

/* the agent that operates to initiate the next pass: it 'observes'
	nexta (signal from the user to act)
	whether the current pass is completed:
		(bs_pass <= 6)&&(bs_pos==(7-bs_pass+1)
	and if so proceeds to the next pass: bs_pass++;
	and resets the position for exchanges: bs_pos, and nexta  */

proc next_pass: nexta
{
        if ((bs_pass <= 6)&&(bs_pos==(7-bs_pass+1))&&(nexta==1)) {
                bs_pass++; bs_pos=1; nexta=0;
        }
}

/* the agent that increments the exchange position, and exchanges adjacent
	elements when appropriate.   It 'observes'
		nexta (signal from the user to act)
		whether the position for exchanges is in range for the pass
			(bs_pos <= 7-bs_pass)
		and if so whether an exchange is necessary
			(val[bs_pos]>val[bs_pos+1])
		and if so exchanges adjacent elements	
			exc(bs_pos, bs_pos+1)
*/

proc next_pos: nexta
{
        if ((bs_pos <= 7-bs_pass)&&(nexta==1)) {
                if ((val[bs_pos]>val[bs_pos+1])) {
                        exchange(bs_pos, bs_pos+1);
                }
                bs_pos++;
                nexta=0;
        }
}
