/* General version */
/* Sort out scroll bar widgets, when dragging bar don't let it get shorter */
/* Start with no windows, then have a proc create_win(x); to create x display windows. */
/* Also have a proc called load_list(l); which takes a list creates the right number of windows and  */
/* fills them with the data required */

/* function returns the maximum value in a particular field of a list */
/* e.g l = [ [2,3],[4,5],[6,7]], maxinfieldoflist(l,1)=6 */

addrecords = 10000;
addfields = 10001;

func maxinfieldoflist {
 para l,fno;
 auto i,result;
 result = -100000000;

 for (i=1;i<=l#; i++)
 {
   if (l[i][fno]>result) {result=l[i][fno];}   
 }
 return result;
}

/* function returns the minimum value in a particular field of a list */
/* e.g l = [ [2,3],[4,5],[6,7]], maininfieldoflist(l,2)=3 */

func mininfieldoflist {
 para l,fno;
 auto i,result;
 result = 100000000;

 for (i=1;i<=l#; i++)
 {
   if (l[i][fno]<result) {result=l[i][fno];}   
 }
 return result;
}

/* function looks at the complex list structure and returns the maximum number of elements in a single sublist */
/* e.g maxinanysublist(h) { h= [ [2,3],[[1],[3,4,5,6]],[3,4],2]} = 4; */

func maxinanysublist {
para l;
auto y,z,result;
writeln(l," is the list ");
result = 1;
if (l#!=0) 
{
 for (y=1; y<= l# ; y++ ) 
 {
  if (l[y]#!=0) 
  {
   for (z=1; z<= l[y]# ; z++ )
   {
     if (l[y][z]#>result) {result=l[y][z]#;}
   }
  }
 }
}
writeln(result," is max in any sublist ");
return result;
}

/* the possible values of the houses parameters, max and min values - should be dependent on the
actual values of the houses parameters - are now!, whenever houses data is changed then this definition is automatically
updated to change the new values of the max and mins. When the rangeextremes change then the refresh procedure is automatically 
triggered since the location of some of the blocks will change. 
*/

rangeextremes is [];

data is [];
datadisplay is [];

func max 
{ 
para a,b;
if (a>b) {return a;} else {return b;}
}

func min
{
para a,b;
if (a<b) {return a;} else {return b;}
}

constraints is [];

/* End of House Data Definitions */

numberofdataelements is data#;
numberofcategories is (data#==0)? 0 : data[1]#;
numberofranges is 10;
offcolour = "grey";
oncolour = "green";
highlightcolour = "red";
winlist = [];
viewportlist = [];

squareheight is 100.0 / numberofranges;  /* we use 100 as a constant because this is the xmax or ymaxof the DONALD drawing in the*/
squarewidth is  100.0 / numberofranges;  /* scout window - changing the size of the window will increase the width of the blocks*/
				      /* automatically, hence not dependent on the width/height SCOUT window parameters.        */



/* this procedure adds another data element to the list. for example we may have data pertaining to 20 customers but we want */
/* to add more. This does it and maintains all the releavant dependencies using a similar method as the restaturant simulation*/
/* we cannot use append or we lose the definition of a list as an *is* dependency. So we have to access the symboltable,extract*/
/* the definition and then reexecute it when we have added the appropriate data to the string */
/* Must change px = ; gx = ; rx = ; */
/* Then update houses,housesdisplay,constraints,pxon,rxon,gxon */

/* start refers to the field number to start adding into */
/* choice refers to whether to add new records, or add new fields */

proc adddataitem 
{
para m,datanum,start,choice; /* a list , i.e l = [pi,ri,gi]; */
auto a,b,c,d,i,first,l;
auto temp,temp2,temp3;

l = m[datanum];
writeln(l);
/* Autocalc is turned off because for the duration of this procedure the state is in transition and has no meaning in this */
/* transitional phase */
autocalc = 0;
 
 if (data#==0) {first = TRUE;} else {first=FALSE;}

 writeln("L is ",l);

/* **** ADDING RECORDS SECTION **** */
 if (choice==addrecords)
 {
writeln("ADDING RECORD!!!");
  for (i=1; i<=l#; i++) 
  {
   a = str(l[i]);writeln(a);
   execute("d"//str(i)//""//str(numberofdataelements+1)//" is "//str(a)//";
 	   ");
  }

  temp = symboltext("data");
  temp2 = substr(temp,1,temp#-2);
  temp3 = "[";
  for (i=1; i<=l#; i++) 
  {
  temp3 =strcat(temp3,"d",str(i),str(numberofdataelements+1),",");
  }
  temp3 = strcat(substr(temp3,1,temp3#-1),"]");
  if (first) {temp4=strcat(temp2,temp3,"];");} else {temp4 = strcat(temp2,",",temp3,"];");}
  execute("data is "//str(temp4)//"");
writeln("1");
  temp = symboltext("constraints");
  temp2 = substr(temp,1,temp#-2);
  temp3 = strcat("constraint(",str(numberofdataelements),",");

  for (i=1; i<=l#; i++)
  {
  temp3=strcat(temp3,"d",str(i),str(numberofdataelements),",");
  }

  temp3 = strcat(substr(temp3,1,temp3#-1),")");
  if (first) {temp4=strcat(temp2,temp3,"];");} else {temp4 = strcat(temp2,",",temp3,"];");}
  execute("constraints is "//str(temp4)//"");
writeln("2");
  for (i=1; i<=l#; i++)
  {
   execute("d"//str(i)//""//str(numberofdataelements)//"on is constraints["//str(numberofdataelements)//"];
	   ");
  }
writeln("3");
  temp = symboltext("datadisplay");
  temp2 = substr(temp,1,temp#-2);
  
  temp3 = "[";  

  for (i=1; i<=l#; i++)
  {
   temp3=strcat(temp3,"d",str(i),str(numberofdataelements),"on,");
  }
  temp3 = strcat(substr(temp3,1,temp3#-1),"]");
  if (first) {temp4=strcat(temp2,temp3,"];");} else {temp4 = strcat(temp2,",",temp3,"];");}
  execute("datadisplay is "//str(temp4)//"");
writeln("4");
  if (first) 
  {
    

    temp = "[";

    for (i=1; i<=l#; i++)
    {
      temp=strcat(temp,"[mininfieldoflist(data,"//str(i)//"),maxinfieldoflist(data,"//str(i)//")],");
    }
    temp3 = strcat(substr(temp,1,temp#-1),"];");
    execute("rangeextremes is "//str(temp3)//"");
writeln("5"); 
  /* ****** */
    temp = "[";
writeln("5.1");
    for (i=1; i<=l#; i++) 
    {
	writeln("5.2");writeln(l#);
temp=strcat(temp,"[rangeextremes["//str(i)//"][1]+(("//str(winlist[i])//"HScrollBar_left/
"//str(winlist[i])//"width)*(rangeextremes["//str(i)//"][2]-rangeextremes["//str(i)//"][1])),
rangeextremes["//str(i)//"][1]+(("//str(winlist[i])//"HScrollBar_right/"//str(winlist[i])//
"width)*(rangeextremes["//str(i)//"][2]-rangeextremes["//str(i)//"][1]))],");
writeln("5.3");
    }
    temp2 = strcat(substr(temp,1,temp#-1),"];");
writeln("5.5");
    execute("interface_constraints is "//str(temp2)//"");
writeln("6");
  /* ****** */

    temp = "(";
    for (i=1; i<=l#; i++) 
    {
      temp =strcat(temp,"(data[x]["//str(i)//"]>=interface_constraints["//str(i)//"][1])&&(data[x]["//str(i)//
"]<=interface_constraints["//str(i)//"][2])&&");
    }
    temp2 = strcat(substr(temp,1,temp#-2),")");

    execute("

	    func constraint
	    {
	     para x,a,b,c;
	     auto result;
	     if "//str(temp2)//" {result=1;} else {result=0;}
	     return result;
	    }
	    ");
writeln("7");


  }

 }
/* **** END OF ADDING RECORDS BIT **** */

/* **** ADDING FIELDS BIT **** */

 if (choice==addfields) 
 {
first = TRUE; /* need to alter rangeextrems, constraints etc if adding new fields */
writeln("ADDING FIELDS!!!");
  for (i=1; i<=m#; i++) 
  {
   for (j=1; j<=m[i]#; j++) 
   {
    a = str(m[i][j]);writeln(a);
    execute("d"//str(start+j-1)//""//str(i)//" is "//str(a)//";
  	    ");
   }
  }

  temp = "[";

  for (i=1; i<=data#; i++) 
  {
    temp = strcat(temp,"[");
    for (j=1; j<= data[1]#+l#; j++) 
    {
      temp = strcat(temp,"d",str(j),str(i),",");
    }
    temp = strcat(substr(temp,1,temp#-1),"],");
  }
  temp2 = strcat(substr(temp,1,temp#-1),"];");
  execute("data is "//str(temp2)//"");

  temp = "[";
  for (i=1; i<=data#; i++) 
  {
    temp = strcat(temp,"constraint(",str(i),",");
    for (j=1; j<=data[1]#; j++)
    {
      temp = strcat(temp,"d",str(j),str(i),",");
    }
    temp = strcat(substr(temp,1,temp#-1),"),");
  }
  temp2 = strcat(substr(temp,1,temp#-1),"];");
  execute("constraints is "//str(temp2)//"");

  for (i=start; i<=data#; i++)
  {
    for (j=1; j<=data[1]#; j++)
    {
      execute("d"//str(j)//""//str(i)//"on is constraints["//str(i)//"];
	      ");
    }
  }

  temp = "[";
  for (i=1; i<=data#; i++) 
  {
    temp = strcat(temp,"[");
    for (j=1; j<=data[1]#; j++)
    {
      temp = strcat(temp,"d",str(j),str(i),"on,");
    }
    temp = strcat(substr(temp,1,temp#-1),"],");
  }
  temp2 = strcat(substr(temp,1,temp#-1),"];");
  execute("datadisplay is "//str(temp2)//"");


  if (first) 
  {
    writeln("Updating range extremes etc..",start);

    temp = "[";

    for (i=1; i<=data[1]#; i++)
    {
      temp=strcat(temp,"[mininfieldoflist(data,"//str(i)//"),maxinfieldoflist(data,"//str(i)//")],");
    }
    temp3 = strcat(substr(temp,1,temp#-1),"];");
    execute("rangeextremes is "//str(temp3)//"");
 
  /* ****** */
  
    temp = "[";

    for (i=1; i<=data[1]#; i++) 
    {
	
temp=strcat(temp,"[rangeextremes["//str(i)//"][1]+(("//str(winlist[i])//"HScrollBar_left/"
//str(winlist[i])//"width)*(rangeextremes["//str(i)//"][2]-rangeextremes["//str(i)//"][1])),
rangeextremes["//str(i)//"][1]+(("//str(winlist[i])//"HScrollBar_right/"//str(winlist[i])//
"width)*(rangeextremes["//str(i)//"][2]-rangeextremes["//str(i)//"][1]))],");

    }
    temp2 = strcat(substr(temp,1,temp#-1),"];");
    execute("interface_constraints is "//str(temp2)//"");

  /* ****** */

    temp = "(";
    for (i=1; i<=data[1]#; i++) 
    {
      temp =strcat(temp,"(data[x]["//str(i)//"]>=interface_constraints["//str(i)//"][1])&&(data[x]["//str(i)//
"]<=interface_constraints["//str(i)//"][2])&&");
    }
    temp2 = strcat(substr(temp,1,temp#-2),")");

    execute("

	    func constraint
	    {
	     para x,a,b,c;
	     auto result;
	     if "//str(temp2)//" {result=1;} else {result=0;}
	     return result;
	    }
	    ");



  }
 }

/* **** END OF ADDING FIELDS BIT **** */

/*autocalc = 1;*/
}



/*some window definitions required by proc refresh! */

%scout

point topleft,base_1,base_2,base_3;
integer width,height,spacing,bw,scrollheight,titleheight;
string borderColor;
topleft = {20,40};
height = 200;
width = 200;
spacing = 60;
#bw is border width
bw = 5; 
#scrollheight is the height of the scrollbar
scrollheight = 20;
titleheight = 15;
borderColor = "Maroon";
base_1 = topleft;
base_2 = topleft+{0,height+spacing};
base_3 = topleft+{0,height+spacing+height+spacing};

%eden

/* should change whenever the housing data changes or whenever the number of columns in the bar graph is altered */
/* also whenever the maximum or minimum value of a field changes too */

proc refresh : data,numberofranges,rangeextremes {
auto i,j,k,tempdisplays;
writeln(data,numberofranges,rangeextremes);
/* sets up the display lists, with an arbitrary number of columns to the graph and an arbitrary
number of graphs */
  displays = [];
  for (i=1;i<=numberofcategories;i++)
  {       
    append displays,[];
    for (j=1;j<=numberofranges;j++) 
    {
      append displays[i],[];
    }
  }

/* now go through the housing data and assign each property of each house to the relevant
category. */ 
  for (i=1;i<=numberofdataelements;i++) {
    for (j=1;j<=numberofcategories;j++) {
      if (rangeextremes[j][2]==rangeextremes[j][1]) {k=0;} else
      {
       k=int(numberofranges*(data[i][j]-rangeextremes[j][1])/(rangeextremes[j][2]-rangeextremes[j][1]));
      }
      if (k==0) {k=1;}
      append displays[j][k],i; /* add this house number to the column in the correct display */

      /*now add the donald stuff for the display of each house data element in the windows*/
      execute("%donald
	       viewport "//str(viewportlist[j])//"
	       point or"//str(j)//""//str(i)//"
	       rectangle r"//str(j)//""//str(i)//"
	       or"//str(j)//""//str(i)//"= {"//str(k-1)//"*squarewidth!,"//str(displays[j][k]#-1)//"*squareheight!}
	       r"//str(j)//""//str(i)//"=rectangle(or"//str(j)//""//str(i)//",or"//str(j)//""//str(i)//"+{squareheight!,squarewidth!})
	       ?A_r"//str(j)//""//str(i)//" is (highlighted_house=="//str(i)//")?\"color=red,fill=solid\":((constraints["//str(i)//"]==1)? \"color=green,fill=solid\" : \"color=green,fill=hollow\");

	      ");
  
    }
  } 

writeln(displays);
}


%donald
viewport CONSTRAINTTITLE
label constrainttitlestring
constrainttitlestring = label("Current constraint",{constraintwidth! div 2,titleheight! div 2})

%scout

integer constraintwidth,constraintheight;
point base_4;
string constraint_string;
base_4 = {250,50};
constraintwidth = 350;
constraintheight = 115;

window constraintTitleBar = {
        type: DONALD,
	pict : "CONSTRAINTTITLE",
	box:[base_4-{0,15},base_4+{constraintwidth,0}],
	xmin :0,
	ymin :0,
	xmax :constraintwidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

window constraintdisp = {
                  type: TEXT,
                  frame:([base_4,base_4+{constraintwidth,constraintheight}]),
		  string : constraint_string,
                  bgcolor : "grey",
                  border: 1,
                  relief: "raised",
                  sensitive : ON
};

window constraintBack = {
        type: TEXT,
        string: "",
	frame:([base_4-{bw,15+bw},base_4+{bw+constraintwidth,bw+constraintheight}]),
        bgcolor: borderColor,
        border: 1
};

%donald
viewport SELECTEDHOUSETITLE
label selectedhousetitlestring
selectedhousetitlestring = label("Selected customer",{selectedhousewidth! div 2,titleheight! div 2})

%scout

integer selectedhousewidth,selectedhouseheight;
point base_5;
string selectedhouse_string;
base_5 = {250,250};
selectedhousewidth = 200;
selectedhouseheight = 65;

%eden
highlighted_house = 0;
/* NEED TO CHANGE FOLLOWING DEPENDENCY AS WELL!!!!! */
selectedhouse_string is (highlighted_house!=0) ? strcat("\n Arrived : ",str(data[highlighted_house][1])," time\n Size    : "
,str(data[highlighted_house][2])," people\n Spent   : ",str(data[highlighted_house][3]),
" pounds\n") : "\n Arrived : \n Size    : \n Spent   : \n";
%scout

window selectedhouseTitleBar = {
        type: DONALD,
	pict : "SELECTEDHOUSETITLE",
	box:[base_5-{0,15},base_5+{selectedhousewidth,0}],
	xmin :0,
	ymin :0,
	xmax :selectedhousewidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

window selectedhousedisp = {
                  type: TEXT,
		  string : selectedhouse_string,
                  frame:([base_5,base_5+{selectedhousewidth,selectedhouseheight}]),
                  bgcolor : "grey",
                  border: 1,
                  relief: "raised",
                  sensitive : ON
};

window selectedhouseBack = {
        type: TEXT,
        string: "",
	frame:([base_5-{bw,15+bw},base_5+{bw+selectedhousewidth,bw+selectedhouseheight}]),
        bgcolor: borderColor,
        border: 1
};


display constraintwindow = <constraintTitleBar/constraintdisp/constraintBack>;
display selectedhousewindow = <selectedhouseTitleBar/selectedhousedisp/selectedhouseBack>;

screen = constraintwindow & selectedhousewindow;

%eden
originalPos = [0,0];
movingselectedhouseDisplay = FALSE;

proc selectedhouseDisplayMove: selectedhouseTitleBar_mousePos

{
        
writeln(selectedhouseTitleBar_mouse); writeln(selectedhouseTitleBar_mousePos);

  if (selectedhouseTitleBar_mouse!=@) 
  {
        if ((selectedhouseTitleBar_mouse[2]==4)&&(movingselectedhouseDisplay==FALSE))
        { 
                originalPos[1] = selectedhouseTitleBar_mouse[4];
                originalPos[2] = selectedhouseTitleBar_mouse[5]; /* records where last clicked */
                movingselectedhouseDisplay = TRUE;
        }
        else if (movingselectedhouseDisplay)
        {writeln("2",originalPos);
                base_5[1] = base_5[1] + (selectedhouseTitleBar_mousePos[1] - originalPos[1]);
		eager();
                base_5[2] = base_5[2] - (selectedhouseTitleBar_mousePos[2] - originalPos[2]);
                eager(); /* the vertical is different to the horizontal equation because */
		/* of the fact that DOnald and Scout reference in different directions */
		if (selectedhouseTitleBar_mouse[2]==5) {movingselectedhouseDisplay = FALSE;}
        }
  }
}
movingconstraintDisplay = FALSE;

proc constraintDisplayMove: constraintTitleBar_mousePos

{
        
writeln(constraintTitleBar_mouse); writeln(constraintTitleBar_mousePos);

  if (constraintTitleBar_mouse!=@) 
  {
        if ((constraintTitleBar_mouse[2]==4)&&(movingconstraintDisplay==FALSE))
        { 
                originalPos[1] = constraintTitleBar_mouse[4];
                originalPos[2] = constraintTitleBar_mouse[5]; /* records where last clicked */
                movingconstraintDisplay = TRUE;
        }
        else if (movingconstraintDisplay)
        {writeln("2",originalPos);
                base_4[1] = base_4[1] + (constraintTitleBar_mousePos[1] - originalPos[1]);
		eager();
                base_4[2] = base_4[2] - (constraintTitleBar_mousePos[2] - originalPos[2]);
                eager(); /* the vertical is different to the horizontal equation because */
		/* of the fact that DOnald and Scout reference in different directions */
		if (constraintTitleBar_mouse[2]==5) {movingconstraintDisplay = FALSE;}
        }
  }
}

/*
interface_constraints is 
[ 
[rangeextremes[1][1]+((priceHScrollBar_left/width)*(rangeextremes[1][2]-rangeextremes[1][1])),
rangeextremes[1][1]+((priceHScrollBar_right/width)*(rangeextremes[1][2]-rangeextremes[1][1]))],
[rangeextremes[2][1]+((roomHScrollBar_left/width)*(rangeextremes[2][2]-rangeextremes[2][1])),
rangeextremes[2][1]+((roomHScrollBar_right/width)*(rangeextremes[2][2]-rangeextremes[2][1]))],
[rangeextremes[3][1]+((gardenHScrollBar_left/width)*(rangeextremes[3][2]-rangeextremes[3][1])),
rangeextremes[3][1]+((gardenHScrollBar_right/width)*(rangeextremes[3][2]-rangeextremes[3][1]))]
];
*/

proc constraintbuilder

{

    temp = "(";
    for (i=1; i<=data[1]#; i++) 
    {
      temp =strcat(temp,"(data[x]["//str(i)//"]>=interface_constraints["//str(i)//"][1])&&(data[x]["//str(i)//
"]<=interface_constraints["//str(i)//"][2])&&");
    }
    temp2 = strcat(substr(temp,1,temp#-2),")");

    execute("

	    func constraint
	    {
	     para x,a,b,c;
	     auto result;
	     if "//str(temp2)//" {result=1;} else {result=0;}
	     return result;
	    }
	    ");


/*
execute("

func constraint 
{
para x,a,b,c;
auto result;
if 
((data[x][arrtime]>=interface_constraints[1][1])&&(data[x][arrtime]<=interface_constraints[1][2]) &&
(data[x][groupsize]>=interface_constraints[2][1])&&(data[x][groupsize]<=interface_constraints[2][2]) && 
(data[x][moneyspent]>=interface_constraints[3][1])&&(data[x][moneyspent]<=interface_constraints[3][2]))
{result=1;} else {result=0;}
return result;
}
");
*/
/* now build constraint string for display window */
/*

 MUST REWRITE


constraint_string = "\n Showing all groups ";
got_one = FALSE;
if ((interface_constraints[1][1]!=rangeextremes[1][1])||(interface_constraints[1][2]!=rangeextremes[1][2])||
    (interface_constraints[2][1]!=rangeextremes[2][1])||(interface_constraints[2][2]!=rangeextremes[2][2])||
    (interface_constraints[3][1]!=rangeextremes[3][1])||(interface_constraints[3][2]!=rangeextremes[3][2]))
{
	constraint_string = strcat(constraint_string,"that :-");
	got_one = TRUE;
	if (interface_constraints[1][1]!=rangeextremes[1][1]) 
	{
		constraint_string = strcat(constraint_string,"\n arrived after ",str(int(interface_constraints[1][1]))," time");
	}
	if (interface_constraints[1][2]!=rangeextremes[1][2]) 
	{
		constraint_string = strcat(constraint_string,"\n before ",str(int(interface_constraints[1][2]))," time");
	}
	if (got_one==FALSE) {constraint_string = strcat(constraint_string,"that :-");}
	got_one = TRUE;
	if (interface_constraints[2][1]!=rangeextremes[2][1]) 
	{
		constraint_string = strcat(constraint_string,"\n had more than ",str(int(interface_constraints[2][1]))," people");
	}
	if (interface_constraints[2][2]!=rangeextremes[2][2]) 
	{
		constraint_string = strcat(constraint_string,"\n had less than ",str(int(interface_constraints[2][2]))," people");
		got_one = TRUE;
	}
	if (got_one==FALSE) {constraint_string = strcat(constraint_string,"that :-");}
	if (interface_constraints[3][1]!=rangeextremes[3][1]) 
	{
		constraint_string = strcat(constraint_string,"\n spent more than ",str(interface_constraints[3][1])," pounds");
	}
	if (interface_constraints[3][2]!=rangeextremes[3][2]) 
	{
		constraint_string = strcat(constraint_string,"\n spent less than ",str(interface_constraints[3][2])," pounds");
	}
writeln(constraint_string);
}
*/
}

/* When the mouse enters a window or is in a window display then it could potentially be highlighting a house, we need a window
with x fields so that we can show the current house being displayed. */
/*
highlighted_house = 0;

proc motioninpricedispwindow : pricedisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(pricedisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(pricedisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[1]#)&&(yco<=displays[1][xco]#)) {
    writeln(displays[1][xco][yco]," is the house number here");
    highlighted_house = displays[1][xco][yco];
  } else {highlighted_house = 0;}
}

proc motioninroomdispwindow : roomdisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(roomdisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(roomdisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[2]#)&&(yco<=displays[2][xco]#)) {
    writeln(displays[2][xco][yco]," is the house number here");
    highlighted_house = displays[2][xco][yco];
  } else {highlighted_house = 0;}
}

proc motioningardendispwindow : gardendisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(gardendisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(gardendisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[3]#)&&(yco<=displays[3][xco]#)) {
    writeln(displays[3][xco][yco]," is the house number here");
    highlighted_house = displays[3][xco][yco];
  } else {highlighted_house = 0;}
}
*/

proc constraint_update : interface_constraints

{
  touch(&constraint);

}
