/* General version */
/* Sort out scroll bar widgets, when dragging bar don't let it get shorter */
/* Start with no windows, then have a proc create_win(x); to create x display windows. */
/* Also have a proc called load_list(l); which takes a list creates the right number of windows and  */
/* fills them with the data required */

arrtime = 1;
groupsize = 2;
moneyspent = 3;

/* function returns the maximum value in a particular field of a list */
/* e.g l = [ [2,3],[4,5],[6,7]], maxinfieldoflist(l,1)=6 */

func maxinfieldoflist {
 para l,fno;
 auto i,result;
 result = -10000;

 for (i=1;i<=l#; i++)
 {
   if (l[i][fno]>result) {result=l[i][fno];}   
 }
 return result;
}

/* function returns the minimum value in a particular field of a list */
/* e.g l = [ [2,3],[4,5],[6,7]], maininfieldoflist(l,2)=3 */

func mininfieldoflist {
 para l,fno;
 auto i,result;
 result = 10000;

 for (i=1;i<=l#; i++)
 {
   if (l[i][fno]<result) {result=l[i][fno];}   
 }
 return result;
}

/* function looks at the complex list structure and returns the maximum number of elements in a single sublist */
/* e.g maxinanysublist(h) { h= [ [2,3],[[1],[3,4,5,6]],[3,4],2]} = 4; */

func maxinanysublist {
para l;
auto y,z,result;
writeln(l," is the list ");
result = 1;
if (l#!=0) 
{
 for (y=1; y<= l# ; y++ ) 
 {
  if (l[y]#!=0) 
  {
   for (z=1; z<= l[y]# ; z++ )
   {
     if (l[y][z]#>result) {result=l[y][z]#;}
   }
  }
 }
}
writeln(result," is max in any sublist ");
return result;
}

/* the possible values of the houses parameters, max and min values - should be dependent on the
actual values of the houses parameters - are now!, whenever houses data is changed then this definition is automatically
updated to change the new values of the max and mins. When the rangeextremes change then the refresh procedure is automatically 
triggered since the location of some of the blocks will change. 
*/
rangeextremes is [ [mininfieldoflist(houses,1),maxinfieldoflist(houses,1)],
		   [mininfieldoflist(houses,2),maxinfieldoflist(houses,2)],
		   [mininfieldoflist(houses,3),maxinfieldoflist(houses,3)]];

/* Restaurant Data Definitions*/

p1 = 15;
r1 = 4;
g1 = 55;
p2 = 15;
r2 = 3;
g2 = 33;
p3 = 30;
r3 = 4;
g3 = 48;
p4 = 30;
r4 = 2;
g4 = 18;
p5 = 30;
r5 = 4;
g5 = 60;
p6 = 45;
r6 = 4;
g6 = 49;
p7 = 45;
r7 = 2;
g7 = 23;
p8 = 45;
r8 = 4;
g8 = 52;
p9 = 60;
r9 = 2;
g9 = 27;
p10 = 60;
r10 = 2;
g10= 26;
p11 = 60;
r11 = 4;
g11 = 44;
p12 = 60;
r12 = 2;
g12 = 29;
p13 = 75;
r13 = 4;
g13 = 39;
p14 = 75;
r14 = 2;
g14 = 25;
p15 = 90;
r15 = 2;
g15 = 31;
p16 = 90;
r16 = 2;
g16 = 28;
p17 = 120;
r17 = 2;
g17 = 32;
p18 = 135;
r18 = 4;
g18 = 36;
p19 = 150;
r19 = 2;
g19 = 39;
p20 = 150;
r20 = 2;
g20 = 35;


houses is [ [p1,r1,g1],[p2,r2,g2],[p3,r3,g3],[p4,r4,g4],
[p5,r5,g5],[p6,r6,g6],[p7,r7,g7],[p8,r8,g8],[p9,r9,g9],[p10,r10,g10],[p11,r11,g11],[p12,r12,g12],[p13,r13,g13],[p14,r14,g14],
[p15,r15,g15],[p16,r16,g16],[p17,r17,g17],[p18,r18,g18],[p19,r19,g19],[p20,r20,g20]];

housesdisplay is [ [p1on,r1on,g1on],[p2on,r2on,g2on],[p3on,r3on,g3on],[p4on,r4on,g4on],
[p5on,r5on,g5on],[p6on,r6on,g6on],[p7on,r7on,g7on],[p8on,r8on,g8on],[p9on,r9on,g9on],[p10on,r10on,g10on],[p11on,r11on,g11on],
[p12on,r12on,g2on],[p13on,r13on,g13on],[p14on,r14on,g14on],
[p15on,r15on,g15on],[p16on,r16on,g16on],[p17on,r17on,g17on],[p18on,r18on,g18on],[p19on,r19on,g19on],[p20on,r20on,g20on]];


func max 
{ 
para a,b;
if (a>b) {return a;} else {return b;}
}

func min
{
para a,b;
if (a<b) {return a;} else {return b;}
}

constraints is [ constraint(1,p1,r1,g1),constraint(2,p2,r2,g2),
constraint(3,p3,r3,g3),constraint(4,p4,r4,g4),
constraint(5,p5,r5,g5),constraint(6,p6,r6,g6),
constraint(7,p7,r7,g7),constraint(8,p8,r8,g8),
constraint(9,p9,r9,g9),constraint(10,p10,r10,g10),constraint(11,p11,r11,g11),constraint(12,p12,r12,g12),
constraint(13,p13,r13,g13),constraint(14,p14,r14,g14),
constraint(15,p15,r15,g15),constraint(16,p16,r16,g16),
constraint(17,p17,r17,g17),constraint(18,p18,r18,g18),
constraint(19,p19,r19,g19),constraint(20,p20,r20,g20)];


p1on is constraints[1];
p2on is constraints[2];
p3on is constraints[3];
p4on is constraints[4];
p5on is constraints[5];
p6on is constraints[6];
p7on is constraints[7];
p8on is constraints[8];
p9on is constraints[9];
p10on is constraints[10];
r1on is constraints[1];
r2on is constraints[2];
r3on is constraints[3];
r4on is constraints[4];
r5on is constraints[5];
r6on is constraints[6];
r7on is constraints[7];
r8on is constraints[8];
r9on is constraints[9];
r10on is constraints[10];
g1on is constraints[1];
g2on is constraints[2];
g3on is constraints[3];
g4on is constraints[4];
g5on is constraints[5];
g6on is constraints[6];
g7on is constraints[7];
g8on is constraints[8];
g9on is constraints[9];
g10on is constraints[10];
p11on is constraints[11];
p12on is constraints[12];
p13on is constraints[13];
p14on is constraints[14];
p15on is constraints[15];
p16on is constraints[16];
p17on is constraints[17];
p18on is constraints[18];
p19on is constraints[19];
p20on is constraints[20];
r11on is constraints[11];
r12on is constraints[12];
r13on is constraints[13];
r14on is constraints[14];
r15on is constraints[15];
r16on is constraints[16];
r17on is constraints[17];
r18on is constraints[18];
r19on is constraints[19];
r20on is constraints[20];
g11on is constraints[11];
g12on is constraints[12];
g13on is constraints[13];
g14on is constraints[14];
g15on is constraints[15];
g16on is constraints[16];
g17on is constraints[17];
g18on is constraints[18];
g19on is constraints[19];
g20on is constraints[20];


/* End of House Data Definitions */

numberofhouses is houses#;
numberofcategories is houses[1]#;
numberofranges is 10;
offcolour = "grey";
oncolour = "green";
highlightcolour = "red";
viewportlist = ["PRICEDISPLAY","ROOMDISPLAY","GARDENDISPLAY"];
squareheight is 100.0 / numberofranges;  /* we use 100 as a constant because this is the xmax or ymaxof the DONALD drawing in the*/
squarewidth is  100.0 / numberofranges;  /* scout window - changing the size of the window will increase the width of the blocks*/
				      /* automatically, hence not dependent on the width/height SCOUT window parameters.        */



/* this procedure adds another data element to the list. for example we may have data pertaining to 20 customers but we want */
/* to add more. This does it and maintains all the releavant dependencies using a similar method as the restaturant simulation*/
/* we cannot use append or we lose the definition of a list as an *is* dependency. So we have to access the symboltable,extract*/
/* the definition and then reexecute it when we have added the appropriate data to the string */
/* Must change px = ; gx = ; rx = ; */
/* Then update houses,housesdisplay,constraints,pxon,rxon,gxon */

proc adddataitem 
{
para l; /* a list , i.e l = [pi,ri,gi]; */
auto a,b,c,d;
auto temp,temp2,temp3;

/* Autocalc is turned off because for the duration of this procedure the state is in transition and has no meaning in this */
/* transitional phase */

autocalc = 0;
  a = str(l[1]);
  b = str(l[2]);
  c = str(l[3]);
  execute("p"//str(numberofhouses+1)//" is "//str(a)//";
	   r"//str(numberofhouses+1)//" is "//str(b)//";
	   g"//str(numberofhouses+1)//" is "//str(c)//";
	  ");

  temp = symboldetail("houses")[3];
  temp2 = substr(temp,1,temp#-2);
  temp3 = strcat("[p",str(numberofhouses+1),",r",str(numberofhouses+1),",g",str(numberofhouses+1),"]");
  temp4 = strcat(temp2,",",temp3,"];");
  execute("houses is "//str(temp4)//"");


  temp = symboldetail("constraints")[3];
  temp2 = substr(temp,1,temp#-2);
  temp3=strcat("constraint(",str(numberofhouses),",p",str(numberofhouses),",r",str(numberofhouses),",g",str(numberofhouses),")");
  temp4 = strcat(temp2,",",temp3,"];");
  execute("constraints is "//str(temp4)//"");

  execute("p"//str(numberofhouses)//"on is constraints["//str(numberofhouses)//"];
	   r"//str(numberofhouses)//"on is constraints["//str(numberofhouses)//"];
	   g"//str(numberofhouses)//"on is constraints["//str(numberofhouses)//"];
	  ");

  temp = symboldetail("housesdisplay")[3];
  temp2 = substr(temp,1,temp#-2);
  temp3 = strcat("[p",str(numberofhouses),"on,r",str(numberofhouses),"on,g",str(numberofhouses),"on]");
  temp4 = strcat(temp2,",",temp3,"];");
  execute("housesdisplay is "//str(temp4)//"");
autocalc = 1;
}

/*some window definitions required by proc refresh! */

%scout

point topleft,base_1,base_2,base_3;
integer width,height,spacing,bw,scrollheight,titleheight;
string borderColor;
topleft = {20,40};
height = 200;
width = 200;
spacing = 60;
#bw is border width
bw = 5; 
#scrollheight is the height of the scrollbar
scrollheight = 20;
titleheight = 15;
borderColor = "Maroon";
base_1 = topleft;
base_2 = topleft+{0,height+spacing};
base_3 = topleft+{0,height+spacing+height+spacing};

%eden

/* should change whenever the housing data changes or whenever the number of columns in the bar graph is altered */
/* also whenever the maximum or minimum value of a field changes too */

proc refresh : houses,numberofranges,rangeextremes {
auto i,j,k,tempdisplays;
/* sets up the display lists, with an arbitrary number of columns to the graph and an arbitrary
number of graphs */
  displays = [];
  for (i=1;i<=numberofcategories;i++)
  {       
    append displays,[];
    for (j=1;j<=numberofranges;j++) 
    {
      append displays[i],[];
    }
  }

/* now go through the housing data and assign each property of each house to the relevant
category. */ 
  for (i=1;i<=numberofhouses;i++) {
    for (j=1;j<=numberofcategories;j++) {
      k = int(numberofranges*(houses[i][j]-rangeextremes[j][1])/(rangeextremes[j][2]-rangeextremes[j][1]));
      if (k==0) {k=1;}
      append displays[j][k],i; /* add this house number to the column in the correct display */

      /*now add the donald stuff for the display of each house data element in the windows*/
      execute("%donald
	       viewport "//str(viewportlist[j])//"
	       point or"//str(j)//""//str(i)//"
	       rectangle r"//str(j)//""//str(i)//"
	       or"//str(j)//""//str(i)//"= {"//str(k-1)//"*squarewidth!,"//str(displays[j][k]#-1)//"*squareheight!}
	       r"//str(j)//""//str(i)//"=rectangle(or"//str(j)//""//str(i)//",or"//str(j)//""//str(i)//"+{squareheight!,squarewidth!})
	       ?A_r"//str(j)//""//str(i)//" is (highlighted_house=="//str(i)//")?\"color=red,fill=solid\":((constraints["//str(i)//"]==1)? \"color=green,fill=solid\" : \"color=green,fill=hollow\");

	      ");
  
    }
  } 

writeln(displays);
}


/* The data display bit */

%scout
integer pricewidth,priceheight;
pricewidth = width;
priceheight = height;

window pricedisp = {
                  type: DONALD,
                  box: [base_1,base_1+{pricewidth,priceheight}],
                  pict: "PRICEDISPLAY",
                  xmin: 0,
                  xmax: 100,
                  ymin: 0,
                  ymax: 100,
                  bgcolor : "grey",
		  bdcolor : borderColor,
                  border: 1,
                  relief: "raised",
                  sensitive : MOTION
};

window priceBack = {
        type: TEXT,
        string: "",
        frame: ([base_1-{bw,15+bw},base_1+{bw+pricewidth,bw+priceheight+scrollheight}]),
        bgcolor: borderColor,
        border: 1
};

%donald
viewport PRICETITLE
label pricestring
pricestring = label("Arrival time",{pricewidth! div 2,titleheight! div 2})

%scout

window priceTitleBar = {
        type: DONALD,
	pict : "PRICETITLE",
        box: [base_1-{0,15}, base_1+{pricewidth,0}],
	xmin : 0,
	ymin : 0,
	xmax : pricewidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

integer priceHScrollBar_left,priceHScrollBar_right,priceHScrollBar_size;
priceHScrollBar_left = 0;
priceHScrollBar_size = priceHScrollBar_right-priceHScrollBar_left; 
priceHScrollBar_right = pricewidth;

window priceHorizontalScrollBarBack = {
	type : DONALD,
	box : [base_1+{0,priceheight+5},base_1+{0,priceheight-1}+{pricewidth,scrollheight}],
	pict : "PRICEHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : 100,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "sunken",
	sensitive : ON
};

window priceHorizontalScrollBarMain = {
	type : DONALD,
	box :[base_1+{priceHScrollBar_left,priceheight+7},base_1+{0,priceheight-3}+{priceHScrollBar_right,scrollheight}],
	pict : "PRICEHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : priceHScrollBar_size,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window priceHorizontalScrollBarLeftwidget = {
	type : DONALD,
box:[base_1+{priceHScrollBar_left,priceheight+8},base_1+{0,priceheight-4}+{priceHScrollBar_left+3,scrollheight}],
	pict : "PRICEHSCROLLBARLEFTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window priceHorizontalScrollBarRightwidget = {
	type : DONALD,
box:[base_1+{priceHScrollBar_right-3,priceheight+8},base_1+{0,priceheight-4}+{priceHScrollBar_right,scrollheight}],
	pict : "PRICEHSCROLLBARRIGHTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

integer roomwidth,roomheight;
roomwidth = width;
roomheight = height;

window roomdisp = {
                  type: DONALD,
                  box: [base_2,base_2+{roomwidth,roomheight}],
                  pict: "ROOMDISPLAY",
                  xmin: 0,
                  xmax: 100,
                  ymin: 0,
                  ymax: 100,
                  bgcolor : "grey",
		  bdcolor : borderColor,
                  border: 1,
                  relief: "raised",
                  sensitive : MOTION
};

window roomBack = {
        type: TEXT,
        string: "",
        frame: ([base_2-{bw,15+bw},base_2+{bw+roomwidth,bw+roomheight+scrollheight}]),
        bgcolor: borderColor,
        border: 1
};

%donald
viewport ROOMTITLE
label roomstring
roomstring = label("Group size",{roomwidth! div 2,titleheight! div 2})

%scout

window roomTitleBar = {
        type: DONALD,
	pict : "ROOMTITLE",
        box: [base_2-{0,15},base_2+{roomwidth,0}],
	xmin : 0,
	ymin : 0,
	xmax : roomwidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

integer roomHScrollBar_left,roomHScrollBar_right,roomHScrollBar_size;
roomHScrollBar_left = 0;
roomHScrollBar_size = roomHScrollBar_right-roomHScrollBar_left; 
roomHScrollBar_right = 100;

window roomHorizontalScrollBarBack = {
	type : DONALD,
	box : [base_2+{0,roomheight+5},base_2+{0,roomheight-1}+{roomwidth,scrollheight}],
	pict : "ROOMHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : 100,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "sunken",
	sensitive : ON
};

window roomHorizontalScrollBarMain = {
	type : DONALD,
	box :[base_2+{roomHScrollBar_left,roomheight+7},base_2+{0,roomheight-3}+{roomHScrollBar_right,scrollheight}],
	pict : "ROOMHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : roomHScrollBar_size,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window roomHorizontalScrollBarLeftwidget = {
	type : DONALD,
box:[base_2+{roomHScrollBar_left,roomheight+8},base_2+{0,roomheight-4}+{roomHScrollBar_left+3,scrollheight}],
	pict : "ROOMHSCROLLBARLEFTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window roomHorizontalScrollBarRightwidget = {
	type : DONALD,
box:[base_2+{roomHScrollBar_right-3,roomheight+8},base_2+{0,roomheight-4}+{roomHScrollBar_right,scrollheight}],
	pict : "ROOMHSCROLLBARRIGHTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

integer gardenwidth,gardenheight;
gardenwidth = width;
gardenheight = height;

window gardendisp = {
                  type: DONALD,
                  box:[base_3,base_3+{gardenwidth,gardenheight}],
                  pict: "GARDENDISPLAY",
                  xmin: 0,
                  xmax: 100,
                  ymin: 0,
                  ymax: 100,
                  bgcolor : "grey",
		  bdcolor : borderColor,
                  border: 1,
                  relief: "raised",
                  sensitive : MOTION
};

window gardenBack = {
        type: TEXT,
        string: "",
	frame:([base_3-{bw,15+bw},base_3+{bw+gardenwidth,bw+gardenheight+scrollheight}]),
        bgcolor: borderColor,
        border: 1
};

%donald
viewport GARDENTITLE
label gardenstring
gardenstring = label("Money spent",{gardenwidth! div 2,titleheight! div 2})

%scout

window gardenTitleBar = {
        type: DONALD,
	pict : "GARDENTITLE",
	box:[base_3-{0,15},base_3+{gardenwidth,0}],
	xmin :0,
	ymin :0,
	xmax :gardenwidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

integer gardenHScrollBar_left,gardenHScrollBar_right,gardenHScrollBar_size;
gardenHScrollBar_left = 0;
gardenHScrollBar_size = gardenHScrollBar_right-gardenHScrollBar_left; 
gardenHScrollBar_right = width;

window gardenHorizontalScrollBarBack = {
	type : DONALD,
	box : [base_3+{0,gardenheight+5},base_3+{0,gardenheight-1}+{gardenwidth,scrollheight}],
	pict : "GARDENHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : 100,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "sunken",
	sensitive : ON
};

window gardenHorizontalScrollBarMain = {
	type : DONALD,
	box :[base_3+{gardenHScrollBar_left,gardenheight+7},base_3+{0,gardenheight-3}+{gardenHScrollBar_right,scrollheight}],
	pict : "GARDENHSCROLLBAR",
	xmin : 0,
	ymin : 0,
	xmax : gardenHScrollBar_size,
	ymax : 100,
	bgcolor : "grey",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window gardenHorizontalScrollBarLeftwidget = {
	type : DONALD,
box:[base_3+{gardenHScrollBar_left,gardenheight+8},base_3+{0,gardenheight-4}+{gardenHScrollBar_left+3,scrollheight}],
	pict : "GARDENHSCROLLBARLEFTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

window gardenHorizontalScrollBarRightwidget = {
	type : DONALD,
box:[base_3+{gardenHScrollBar_right-3,gardenheight+8},base_3+{0,gardenheight-4}+{gardenHScrollBar_right,scrollheight}],
	pict : "GARDENHSCROLLBARRIGHTWIDGET",
	xmin : 0,
	ymin : 0,
	xmax : 3,
	ymax : 100,
	bgcolor : "black",
	bdcolor : borderColor,
	border : 1,
	relief : "raised",
	sensitive : MOTION
};

%donald
viewport CONSTRAINTTITLE
label constrainttitlestring
constrainttitlestring = label("Current constraint",{constraintwidth! div 2,titleheight! div 2})

%scout

integer constraintwidth,constraintheight;
point base_4;
string constraint_string;
base_4 = {250,50};
constraintwidth = 350;
constraintheight = 115;

window constraintTitleBar = {
        type: DONALD,
	pict : "CONSTRAINTTITLE",
	box:[base_4-{0,15},base_4+{constraintwidth,0}],
	xmin :0,
	ymin :0,
	xmax :constraintwidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

window constraintdisp = {
                  type: TEXT,
                  frame:([base_4,base_4+{constraintwidth,constraintheight}]),
		  string : constraint_string,
                  bgcolor : "grey",
                  border: 1,
                  relief: "raised",
                  sensitive : ON
};

window constraintBack = {
        type: TEXT,
        string: "",
	frame:([base_4-{bw,15+bw},base_4+{bw+constraintwidth,bw+constraintheight}]),
        bgcolor: borderColor,
        border: 1
};

%donald
viewport SELECTEDHOUSETITLE
label selectedhousetitlestring
selectedhousetitlestring = label("Selected customer",{selectedhousewidth! div 2,titleheight! div 2})

%scout

integer selectedhousewidth,selectedhouseheight;
point base_5;
string selectedhouse_string;
base_5 = {250,250};
selectedhousewidth = 200;
selectedhouseheight = 65;

%eden
selectedhouse_string is (highlighted_house!=0) ? strcat("\n Arrived : ",str(houses[highlighted_house][1])," time\n Size    : "
,str(houses[highlighted_house][2])," people\n Spent   : ",str(houses[highlighted_house][3]),
" pounds\n") : "\n Arrived : \n Size    : \n Spent   : \n";
%scout

window selectedhouseTitleBar = {
        type: DONALD,
	pict : "SELECTEDHOUSETITLE",
	box:[base_5-{0,15},base_5+{selectedhousewidth,0}],
	xmin :0,
	ymin :0,
	xmax :selectedhousewidth,
	ymax : titleheight,
        border: 1,  
        fgcolor: "white",
        bgcolor: borderColor,
        sensitive: MOTION
};

window selectedhousedisp = {
                  type: TEXT,
                  frame:([base_5,base_5+{selectedhousewidth,selectedhouseheight}]),
		  string : selectedhouse_string,
                  bgcolor : "grey",
                  border: 1,
                  relief: "raised",
                  sensitive : ON
};

window selectedhouseBack = {
        type: TEXT,
        string: "",
	frame:([base_5-{bw,15+bw},base_5+{bw+selectedhousewidth,bw+selectedhouseheight}]),
        bgcolor: borderColor,
        border: 1
};


display prices  =<priceTitleBar/pricedisp/priceHorizontalScrollBarLeftwidget/priceHorizontalScrollBarRightwidget/priceHorizontalScrollBarMain/priceHorizontalScrollBarBack/priceBack>;
display rooms   =<roomTitleBar/roomdisp/roomHorizontalScrollBarLeftwidget/roomHorizontalScrollBarRightwidget/roomHorizontalScrollBarMain/roomHorizontalScrollBarBack/roomBack>;
display gardens =<gardenTitleBar/gardendisp/gardenHorizontalScrollBarLeftwidget/gardenHorizontalScrollBarRightwidget/gardenHorizontalScrollBarMain/gardenHorizontalScrollBarBack/gardenBack>;
display constraintwindow = <constraintTitleBar/constraintdisp/constraintBack>;
display selectedhousewindow = <selectedhouseTitleBar/selectedhousedisp/selectedhouseBack>;

screen = prices & rooms & gardens & constraintwindow & selectedhousewindow;

%eden
originalPos = [0,0];
movingselectedhouseDisplay = FALSE;

proc selectedhouseDisplayMove: selectedhouseTitleBar_mousePos

{
        
writeln(selectedhouseTitleBar_mouse); writeln(selectedhouseTitleBar_mousePos);

  if (selectedhouseTitleBar_mouse!=@) 
  {
        if ((selectedhouseTitleBar_mouse[2]==4)&&(movingselectedhouseDisplay==FALSE))
        { 
                originalPos[1] = selectedhouseTitleBar_mouse[4];
                originalPos[2] = selectedhouseTitleBar_mouse[5]; /* records where last clicked */
                movingselectedhouseDisplay = TRUE;
        }
        else if (movingselectedhouseDisplay)
        {writeln("2",originalPos);
                base_5[1] = base_5[1] + (selectedhouseTitleBar_mousePos[1] - originalPos[1]);
		eager();
                base_5[2] = base_5[2] - (selectedhouseTitleBar_mousePos[2] - originalPos[2]);
                eager(); /* the vertical is different to the horizontal equation because */
		/* of the fact that DOnald and Scout reference in different directions */
		if (selectedhouseTitleBar_mouse[2]==5) {movingselectedhouseDisplay = FALSE;}
        }
  }
}
movingconstraintDisplay = FALSE;

proc constraintDisplayMove: constraintTitleBar_mousePos

{
        
writeln(constraintTitleBar_mouse); writeln(constraintTitleBar_mousePos);

  if (constraintTitleBar_mouse!=@) 
  {
        if ((constraintTitleBar_mouse[2]==4)&&(movingconstraintDisplay==FALSE))
        { 
                originalPos[1] = constraintTitleBar_mouse[4];
                originalPos[2] = constraintTitleBar_mouse[5]; /* records where last clicked */
                movingconstraintDisplay = TRUE;
        }
        else if (movingconstraintDisplay)
        {writeln("2",originalPos);
                base_4[1] = base_4[1] + (constraintTitleBar_mousePos[1] - originalPos[1]);
		eager();
                base_4[2] = base_4[2] - (constraintTitleBar_mousePos[2] - originalPos[2]);
                eager(); /* the vertical is different to the horizontal equation because */
		/* of the fact that DOnald and Scout reference in different directions */
		if (constraintTitleBar_mouse[2]==5) {movingconstraintDisplay = FALSE;}
        }
  }
}

movinggardenDisplay = FALSE;

proc gardenDisplayMove: gardenTitleBar_mousePos

{
        
writeln(gardenTitleBar_mouse); writeln(gardenTitleBar_mousePos);

  if (gardenTitleBar_mouse!=@) 
  {
        if ((gardenTitleBar_mouse[2]==4)&&(movinggardenDisplay==FALSE))
        { 
                originalPos[1] = gardenTitleBar_mouse[4];
                originalPos[2] = gardenTitleBar_mouse[5]; /* records where last clicked */
                movinggardenDisplay = TRUE;
        }
        else if (movinggardenDisplay)
        {writeln("2",originalPos);
                base_3[1] = base_3[1] + (gardenTitleBar_mousePos[1] - originalPos[1]);
		eager();
                base_3[2] = base_3[2] - (gardenTitleBar_mousePos[2] - originalPos[2]);
                eager(); /* the vertical is different to the horizontal equation because */
		/* of the fact that DOnald and Scout reference in different directions */
		if (gardenTitleBar_mouse[2]==5) {movinggardenDisplay = FALSE;}
        }
  }
}

movingroomDisplay = FALSE;
proc roomDisplayMove: roomTitleBar_mousePos
{
  if (roomTitleBar_mouse!=@) 
  {
        if ((roomTitleBar_mouse[2]==4)&&(movingroomDisplay==FALSE))
        {
                originalPos[1] = roomTitleBar_mouse[4];
                originalPos[2] = roomTitleBar_mouse[5];
                movingroomDisplay = TRUE;
        }
        else if (movingroomDisplay)
        {
                base_2[1] = base_2[1] + roomTitleBar_mousePos[1] - originalPos[1];
                eager();
		base_2[2] = base_2[2] - (roomTitleBar_mousePos[2] - originalPos[2]);
                eager();
		if (roomTitleBar_mouse[2]==5) {movingroomDisplay = FALSE;}
        }
  }
}

movingpriceDisplay = FALSE;
proc priceDisplayMove: priceTitleBar_mousePos
{
  if (priceTitleBar_mouse!=@) 
  {
        if ((priceTitleBar_mouse[2]==4)&&(movingpriceDisplay==FALSE))
        {
                originalPos[1] = priceTitleBar_mouse[4];
                originalPos[2] = priceTitleBar_mouse[5];
                movingpriceDisplay = TRUE;
        }
        else if (movingpriceDisplay)
        {
                base_1[1] = base_1[1] + priceTitleBar_mousePos[1] - originalPos[1];
                base_1[2] = base_1[2] - (priceTitleBar_mousePos[2] - originalPos[2]);
                if (priceTitleBar_mouse[2]==5) {movingpriceDisplay = FALSE;}
        }
  }
}
 

movingroomHorizontalLeftWidget = FALSE;
proc roomMoveHorizontalLeftWidget : roomHorizontalScrollBarLeftwidget_mousePos 

{
  if (roomHorizontalScrollBarLeftwidget_mouse!=@)
  {
    writeln("Moving room left widget...",roomHorizontalScrollBarLeftwidget_mousePos);
    if ((roomHorizontalScrollBarLeftwidget_mouse[2]==4)&&(movingroomHorizontalLeftWidget==FALSE)) 
    {
    	originalPos[1] = roomHorizontalScrollBarLeftwidget_mouse[4];
    	originalPos[2] = roomHorizontalScrollBarLeftwidget_mouse[5];
	movingroomHorizontalLeftWidget = TRUE;
    } 
    else if (movingroomHorizontalLeftWidget)
    {   writeln(roomHScrollBar_left);
        roomHScrollBar_left=max(min(roomHScrollBar_left+roomHorizontalScrollBarLeftwidget_mousePos[1]-originalPos[1],roomHScrollBar_right-3),0);
    	if (roomHorizontalScrollBarLeftwidget_mouse[2]==5) {movingroomHorizontalLeftWidget=FALSE;}
	eager();
    }
  }
}

movingroomHorizontalRightWidget = FALSE;
proc roomMoveHorizontalRightWidget : roomHorizontalScrollBarRightwidget_mousePos 

{
  if (roomHorizontalScrollBarRightwidget_mouse!=@)
  {
    writeln("Moving room right widget...",roomHorizontalScrollBarRightwidget_mousePos);
    if ((roomHorizontalScrollBarRightwidget_mouse[2]==4)&&(movingroomHorizontalRightWidget==FALSE)) 
    {
    	originalPos[1] = roomHorizontalScrollBarRightwidget_mouse[4];
    	originalPos[2] = roomHorizontalScrollBarRightwidget_mouse[5];
	movingroomHorizontalRightWidget = TRUE;
    } 
    else if (movingroomHorizontalRightWidget)
    { writeln(roomHScrollBar_right);
	roomHScrollBar_right=min(max(roomHScrollBar_right+roomHorizontalScrollBarRightwidget_mousePos[1]-originalPos[1],roomHScrollBar_left+3),roomwidth);
    	if (roomHorizontalScrollBarRightwidget_mouse[2]==5) {movingroomHorizontalRightWidget=FALSE;}
	eager();
    }
  }
}

INROOMMOVE = FALSE;
movingroomHorizontalScrollBarMain = FALSE;
proc roomMoveHorizontalMainBar : roomHorizontalScrollBarMain_mousePos 

{

auto s; /* will hold the temporary size variable */

 if (INROOMMOVE==FALSE) 
 {
  INROOMMOVE = TRUE;

  if (roomHorizontalScrollBarMain_mouse!=@)
  {
    writeln("Moving main horizontal scroll bar...",roomHorizontalScrollBarMain_mousePos);
    if ((roomHorizontalScrollBarMain_mouse[2]==4)&&(movingroomHorizontalScrollBarMain==FALSE)) 
    {
    	originalPos[1] = roomHorizontalScrollBarMain_mouse[4];
    	originalPos[2] = roomHorizontalScrollBarMain_mouse[5];
	movingroomHorizontalScrollBarMain = TRUE;
    } 
    else if (movingroomHorizontalScrollBarMain)
    { writeln(roomHScrollBar_left,roomHScrollBar_right);
	s = roomHScrollBar_size;
	roomHScrollBar_left =max(roomHScrollBar_left+(roomHorizontalScrollBarMain_mousePos[1]-originalPos[1]),0);
	if (roomHScrollBar_left+s>roomwidth) {roomHScrollBar_left = roomHScrollBar_right - s;} 
        roomHScrollBar_right = roomHScrollBar_left + s;
	if (roomHScrollBar_right<s) {roomHScrollBar_right = s;}
    	if (roomHorizontalScrollBarMain_mouse[2]==5) {movingroomHorizontalScrollBarMain=FALSE;}

	eager();
    }
  }
 INROOMMOVE = FALSE;
 }
}


/* price moving widget stuff */

movingpriceHorizontalLeftWidget = FALSE;
proc priceMoveHorizontalLeftWidget : priceHorizontalScrollBarLeftwidget_mousePos 

{
  if (priceHorizontalScrollBarLeftwidget_mouse!=@)
  {
    writeln("Moving price left widget...",priceHorizontalScrollBarLeftwidget_mousePos);
    if ((priceHorizontalScrollBarLeftwidget_mouse[2]==4)&&(movingpriceHorizontalLeftWidget==FALSE)) 
    {
    	originalPos[1] = priceHorizontalScrollBarLeftwidget_mouse[4];
    	originalPos[2] = priceHorizontalScrollBarLeftwidget_mouse[5];
	movingpriceHorizontalLeftWidget = TRUE;
    } 
    else if (movingpriceHorizontalLeftWidget)
    {   writeln(priceHScrollBar_left);
	priceHScrollBar_left=max(min(priceHScrollBar_left+priceHorizontalScrollBarLeftwidget_mousePos[1]-originalPos[1],priceHScrollBar_right-3),0);
    	if (priceHorizontalScrollBarLeftwidget_mouse[2]==5) {movingpriceHorizontalLeftWidget=FALSE;}
	eager();
    }
  }
}

movingpriceHorizontalRightWidget = FALSE;
proc priceMoveHorizontalRightWidget : priceHorizontalScrollBarRightwidget_mousePos 

{
  if (priceHorizontalScrollBarRightwidget_mouse!=@)
  {
    writeln("Moving price right widget...",priceHorizontalScrollBarRightwidget_mousePos);
    if ((priceHorizontalScrollBarRightwidget_mouse[2]==4)&&(movingpriceHorizontalRightWidget==FALSE)) 
    {
    	originalPos[1] = priceHorizontalScrollBarRightwidget_mouse[4];
    	originalPos[2] = priceHorizontalScrollBarRightwidget_mouse[5];
	movingpriceHorizontalRightWidget = TRUE;
    } 
    else if (movingpriceHorizontalRightWidget)
    { writeln(priceHScrollBar_right);

priceHScrollBar_right=min(max(priceHScrollBar_right+priceHorizontalScrollBarRightwidget_mousePos[1]-originalPos[1],priceHScrollBar_left+3),pricewidth);
    	if (priceHorizontalScrollBarRightwidget_mouse[2]==5) {movingpriceHorizontalRightWidget=FALSE;}
	eager();
    }
  }
}

movingpriceHorizontalScrollBarMain = FALSE;
proc priceMoveHorizontalMainBar : priceHorizontalScrollBarMain_mousePos 

{
  if (priceHorizontalScrollBarMain_mouse!=@)
  {
    writeln("Moving main horizontal scroll bar...",priceHorizontalScrollBarMain_mousePos);
    if ((priceHorizontalScrollBarMain_mouse[2]==4)&&(movingpriceHorizontalScrollBarMain==FALSE)) 
    {
    	originalPos[1] = priceHorizontalScrollBarMain_mouse[4];
    	originalPos[2] = priceHorizontalScrollBarMain_mouse[5];
	movingpriceHorizontalScrollBarMain = TRUE;
    } 
    else if (movingpriceHorizontalScrollBarMain)
    { writeln(priceHScrollBar_left,priceHScrollBar_right);
	autocalc = 0;
	priceHScrollBar_left =
max(priceHScrollBar_left+(priceHorizontalScrollBarMain_mousePos[1]-originalPos[1]),0);
	priceHScrollBar_right=
min(priceHScrollBar_right+(priceHorizontalScrollBarMain_mousePos[1]-originalPos[1]),pricewidth);

    	if (priceHorizontalScrollBarMain_mouse[2]==5) {movingpriceHorizontalScrollBarMain=FALSE;}
	autocalc = 1;
	eager();
    }
  }
}

/* garden moving widget stuff */

movinggardenHorizontalLeftWidget = FALSE;
proc gardenMoveHorizontalLeftWidget : gardenHorizontalScrollBarLeftwidget_mousePos 

{
  if (gardenHorizontalScrollBarLeftwidget_mouse!=@)
  {
    writeln("Moving garden left widget...",gardenHorizontalScrollBarLeftwidget_mousePos);
    if ((gardenHorizontalScrollBarLeftwidget_mouse[2]==4)&&(movinggardenHorizontalLeftWidget==FALSE)) 
    {
    	originalPos[1] = gardenHorizontalScrollBarLeftwidget_mouse[4];
    	originalPos[2] = gardenHorizontalScrollBarLeftwidget_mouse[5];
	movinggardenHorizontalLeftWidget = TRUE;
    } 
    else if (movinggardenHorizontalLeftWidget)
    {   writeln(gardenHScrollBar_left);
	gardenHScrollBar_left=max(min(gardenHScrollBar_left+gardenHorizontalScrollBarLeftwidget_mousePos[1]-originalPos[1],gardenHScrollBar_right-3),0);
    	if (gardenHorizontalScrollBarLeftwidget_mouse[2]==5) {movinggardenHorizontalLeftWidget=FALSE;}
	eager();
    }
  }
}

movinggardenHorizontalRightWidget = FALSE;
proc gardenMoveHorizontalRightWidget : gardenHorizontalScrollBarRightwidget_mousePos 

{
  if (gardenHorizontalScrollBarRightwidget_mouse!=@)
  {
    writeln("Moving garden right widget...",gardenHorizontalScrollBarRightwidget_mousePos);
    if ((gardenHorizontalScrollBarRightwidget_mouse[2]==4)&&(movinggardenHorizontalRightWidget==FALSE)) 
    {
    	originalPos[1] = gardenHorizontalScrollBarRightwidget_mouse[4];
    	originalPos[2] = gardenHorizontalScrollBarRightwidget_mouse[5];
	movinggardenHorizontalRightWidget = TRUE;
    } 
    else if (movinggardenHorizontalRightWidget)
    { writeln(gardenHScrollBar_right);
	gardenHScrollBar_right=min(max(gardenHScrollBar_right+gardenHorizontalScrollBarRightwidget_mousePos[1]-originalPos[1],gardenHScrollBar_left+3),gardenwidth);
    	if (gardenHorizontalScrollBarRightwidget_mouse[2]==5) {movinggardenHorizontalRightWidget=FALSE;}
	eager();
    }
  }
}

movinggardenHorizontalScrollBarMain = FALSE;
proc gardenMoveHorizontalMainBar : gardenHorizontalScrollBarMain_mousePos 

{
  if (gardenHorizontalScrollBarMain_mouse!=@)
  {
    writeln("Moving main horizontal scroll bar...",gardenHorizontalScrollBarMain_mousePos);
    if ((gardenHorizontalScrollBarMain_mouse[2]==4)&&(movinggardenHorizontalScrollBarMain==FALSE)) 
    {
    	originalPos[1] = gardenHorizontalScrollBarMain_mouse[4];
    	originalPos[2] = gardenHorizontalScrollBarMain_mouse[5];
	movinggardenHorizontalScrollBarMain = TRUE;
    } 
    else if (movinggardenHorizontalScrollBarMain)
    { writeln(gardenHScrollBar_left,gardenHScrollBar_right);
	autocalc = 0;
	gardenHScrollBar_left =
max(gardenHScrollBar_left+(gardenHorizontalScrollBarMain_mousePos[1]-originalPos[1]),0);
	gardenHScrollBar_right=
min(gardenHScrollBar_right+(gardenHorizontalScrollBarMain_mousePos[1]-originalPos[1]),gardenwidth);

    	if (gardenHorizontalScrollBarMain_mouse[2]==5) {movinggardenHorizontalScrollBarMain=FALSE;}
	autocalc = 1;
	eager();
    }
  }
}

interface_constraints is 
[ 
[rangeextremes[1][1]+((priceHScrollBar_left/width)*(rangeextremes[1][2]-rangeextremes[1][1])),
rangeextremes[1][1]+((priceHScrollBar_right/width)*(rangeextremes[1][2]-rangeextremes[1][1]))],
[rangeextremes[2][1]+((roomHScrollBar_left/width)*(rangeextremes[2][2]-rangeextremes[2][1])),
rangeextremes[2][1]+((roomHScrollBar_right/width)*(rangeextremes[2][2]-rangeextremes[2][1]))],
[rangeextremes[3][1]+((gardenHScrollBar_left/width)*(rangeextremes[3][2]-rangeextremes[3][1])),
rangeextremes[3][1]+((gardenHScrollBar_right/width)*(rangeextremes[3][2]-rangeextremes[3][1]))]
];

proc constraintbuilder : interface_constraints 

{

execute("

func constraint 
{
para x,a,b,c;
auto result;
if 
((houses[x][arrtime]>=interface_constraints[1][1])&&(houses[x][arrtime]<=interface_constraints[1][2]) &&
(houses[x][groupsize]>=interface_constraints[2][1])&&(houses[x][groupsize]<=interface_constraints[2][2]) && 
(houses[x][moneyspent]>=interface_constraints[3][1])&&(houses[x][moneyspent]<=interface_constraints[3][2]))
{result=1;} else {result=0;}
return result;
}
");

/* now build constraint string for display window */

constraint_string = "\n Showing all groups ";
got_one = FALSE;
if ((interface_constraints[1][1]!=rangeextremes[1][1])||(interface_constraints[1][2]!=rangeextremes[1][2])||
    (interface_constraints[2][1]!=rangeextremes[2][1])||(interface_constraints[2][2]!=rangeextremes[2][2])||
    (interface_constraints[3][1]!=rangeextremes[3][1])||(interface_constraints[3][2]!=rangeextremes[3][2]))
{
	constraint_string = strcat(constraint_string,"that :-");
	got_one = TRUE;
	if (interface_constraints[1][1]!=rangeextremes[1][1]) 
	{
		constraint_string = strcat(constraint_string,"\n arrived after ",str(int(interface_constraints[1][1]))," time");
	}
	if (interface_constraints[1][2]!=rangeextremes[1][2]) 
	{
		constraint_string = strcat(constraint_string,"\n before ",str(int(interface_constraints[1][2]))," time");
	}
	if (got_one==FALSE) {constraint_string = strcat(constraint_string,"that :-");}
	got_one = TRUE;
	if (interface_constraints[2][1]!=rangeextremes[2][1]) 
	{
		constraint_string = strcat(constraint_string,"\n had more than ",str(int(interface_constraints[2][1]))," people");
	}
	if (interface_constraints[2][2]!=rangeextremes[2][2]) 
	{
		constraint_string = strcat(constraint_string,"\n had less than ",str(int(interface_constraints[2][2]))," people");
		got_one = TRUE;
	}
	if (got_one==FALSE) {constraint_string = strcat(constraint_string,"that :-");}
	if (interface_constraints[3][1]!=rangeextremes[3][1]) 
	{
		constraint_string = strcat(constraint_string,"\n spent more than ",str(interface_constraints[3][1])," pounds");
	}
	if (interface_constraints[3][2]!=rangeextremes[3][2]) 
	{
		constraint_string = strcat(constraint_string,"\n spent less than ",str(interface_constraints[3][2])," pounds");
	}
writeln(constraint_string);
}

}

/* When the mouse enters a window or is in a window display then it could potentially be highlighting a house, we need a window
with x fields so that we can show the current house being displayed. */

highlighted_house = 0;

proc motioninpricedispwindow : pricedisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(pricedisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(pricedisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[1]#)&&(yco<=displays[1][xco]#)) {
    writeln(displays[1][xco][yco]," is the house number here");
    highlighted_house = displays[1][xco][yco];
  } else {highlighted_house = 0;}
}

proc motioninroomdispwindow : roomdisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(roomdisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(roomdisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[2]#)&&(yco<=displays[2][xco]#)) {
    writeln(displays[2][xco][yco]," is the house number here");
    highlighted_house = displays[2][xco][yco];
  } else {highlighted_house = 0;}
}

proc motioningardendispwindow : gardendisp_mousePos 
{
auto xco,yco;

  /* Caclulate whether a house is highlighted or not using equation*/

  xco = int(gardendisp_mousePos[1] / (100/numberofranges)) + 1;
  yco = int(gardendisp_mousePos[2] / (100/numberofranges)) + 1;
  if ((xco<=displays[3]#)&&(yco<=displays[3][xco]#)) {
    writeln(displays[3][xco][yco]," is the house number here");
    highlighted_house = displays[3][xco][yco];
  } else {highlighted_house = 0;}
}


