%scout
# meta-interaction: action by the modeller to change the
# state of the computer model e.g. in order to make more
# space on the screen, by relocating image of clock and
# by shrinking the clock image.

%scout
clockwinScale = 1;
clockwinPos = {10,10};

%donald
# extension 0

# clock/t is a donald int variable
# representing time elapsed in minutes
# from midnight (1440 per day)

clock/t = 134
clock/t = 670

# semantics of adding time?
# should a design for a watch have a particular time on it?

# potentially represents aspect of watch state that is beyond user control
# - reflecting actual user agency over time in real-world context

%eden
include("autotime.e");
/* this maintains a variable tnsecs that records number of seconds
	elapsed in real-time from an arbitrary initial time: demo by
	proc wtnsecs: tnsecs { writeln(tnsecs); }
*/

_clock_t is abs_time(tn) / 60;	/* integer division, so integer result */

/* user agency over whether watch is running, realised by "Interrupt"
	on tkeden input interface (construe as e.g. "remove battery") and
	touch(&new_time);
	(which we can construe as e.g. "insert battery")
*/

/* also have two kinds of watch: those where operation is perceptible
	(e.g. via audible tick) and those where operation indiscernible
	proc wtnsecs {};
*/

%donald
clock/t = 0
# potentially represents a user of the watch - setting the time
# many possible reasons for setting the time (e.g. watch is fast,
# user is in new time zone, designer wants to view hands overlapping).

%eden
uk_time is tnsecs / 60;
japan_time is uk_time + 480;
_clock_t is japan_time;

%donald
# extension 1

# edge is the circle that defines the outer rim of the clock face
# adding inner circle can be construed as a designer's action

within clock {
	circle inner_edge
	real width_edge
	inner_edge = circle(centre, radius - width_edge)
 	width_edge = 20.0

# aesthetic issue of where to place the inner edge

	width_edge = 10.0
}

# note that such action is construed as changing the watch
# as opposed to changing the state of the watch

# extension 2
 
# adding a second hand: potentially a design decision, but could also
# be construed as taking account of a hitherto neglected observable

%donald
within clock {
	line secHand
	real secAngle, size_secHand
	secHand = [centre + {size_secHand*radius @ secAngle}, centre]
	size_secHand = 0.8
}

# no position for second hand yet, so not on display
# before we give proper definition of dependency on time, can experiment
# with arbitrary values (meta-interaction by the model constructor

clock/secAngle = pi

# also might introduce explicit observables for size_minHand etc here
within clock {
	real size_minHand
	size_minHand = 0.75
	minHand = [centre + {size_minHand * radius @ minAngle}, centre]
}

# now specify the position of the second hand as function of time 	
%eden
sec_mod_60 is tnsecs % 60;
/* determine how many seconds elapsed since last whole minute time */

%donald
within clock {
	secAngle = (pi div 2.0) - float (sec_mod_60!)* (pi div 30.0)
}

%eden
A_clock_secHand = "color=red";

/* construed as a design feature */

/* compare the following implausible associations of observables */

_clock_size_secHand is (float(sec_mod_60) / 60.0) * _clock_size_minHand;

%donald
# the minute hand comes loose
clock/minAngle = - pi div 2

# repair is difficult, unless have observed correct configuration first
# can restore to working order by restoring original definition
clock/minAngle = (pi div 2.0) - float (clock/t mod 60) * (pi div 30.0)


%scout
window clockwin = {
    type: DONALD
    box: [clockwinNW, clockwinSE]
    pict: "CLOCK"
    xmin: 30
    ymin: 370
    xmax: 370
    ymax: 30
    bgcolor: "white"
    border: 1
};

# a mirror image clock

%donald
clock/radius = -100.0

# the upside-down clock


