%donald
viewport NEWCLOCK
shape rotclock
real rotangle
rotangle = 0.0
rotclock = rot(clock, clock/centre, rotangle)
%scout
window clockwin = {
    type: DONALD
    box: [clockwinNW, clockwinSE]
    pict: "NEWCLOCK"
    xmin: 30
    ymin: 30
    xmax: 370
    ymax: 370
    bgcolor: "white"
    border: 1
};

%donald
# rotangle = -clock/hourAngle - (pi div 2.0)
# positions the hour hand at 6 o'clock

real hrAngle, mnAngle
hrAngle = -clock/hourAngle - (pi div 2.0)
mnAngle = -clock/minAngle - (pi div 2.0)

%eden
func moment {
	para hrA, mnA, theta;
	return (0.5*sin(theta-hrA) - 0.75*sin(mnA-theta));
}

/* this formulae to compute the moment of the hands is
based on the fixed lengths of 0.5 and 0.75 for the hour
and minute hands of the clock.  They could be
parametrised, as in ext0.d
*/

hA = _hrAngle;
mA = _mnAngle;
momentH is moment(_hrAngle, _mnAngle, hA);
momentHM is moment(_hrAngle, _mnAngle, (hA+mA)/2.0);
momentM is moment(_hrAngle, _mnAngle, mA);
writeln(momentH); writeln(momentHM); writeln(momentM);

/* update_momentHM is the iteration to bring the clock
into equilibrium, taking account of the moments of the
hands.  It proceeds until momentHM is very small.
*/

proc update_momentMH: momentHM {
	if (momentHM * momentHM > 0.000000001) {
		if (momentH*momentHM<0) mA = (hA+mA)/2; else
		if(momentM*momentHM<0) hA = (hA+mA)/2;
	}
}

_rotangle is (hA+mA) / 2;

/* update_newtime is the action that triggers the
rebalancing of the clock after a movement of the hands
*/

proc update_newtime: _clock_t {
	hA = _hrAngle;
	mA = _mnAngle;
}

/* _clock_t is i; i++; i=i;
	proc wmomentHM: i { writeln(momentHM);}
*/

/*
for (i=1;i<=100;i++) {
	_clock_t = i;
	eager();
}
*/

/* there are some curious aspects of the behaviour - esp.
in the neighbourhood of clock/t = 360, where the hands
are unexpectedly inverted.  There may well be other
unrealistic aspects of the behaviour, but these have not
been fully explored.
*/

/* can run the above simulation after including artclock.e,
and then set blankedge to 160 to disclose the clock faces
fully.  The leftmost clock then operates in the rotating
face mode, and the others are normal.
*/